<?php
// $Id:
define('BLOCK_TEMPLATES_PATH', drupal_get_path('module', 'code_gen') .'/templates/block');
function code_gen_block_module() {
  $content = '<div id="code_gen_create_block_form">';
    $content .= drupal_get_form('code_gen_create_block_form');
  $content .= '</div>';
  return $content;
}

function code_gen_create_block_form(&$form_state) {
  $form = array();
  $form['module_name'] = array(
    "#type" => "textfield",
    "#title" => t("Module name"),
    "#description" => t("Name of module to auto generate."),
    '#required' => TRUE,
  );
  $form['block_name'] = array(
    "#type" => "textfield",
    "#title" => t("Block name"),
    "#description" => t("Name of block to auto generate."),
    '#required' => TRUE,
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Create'),
  );

  return $form;
}

function code_gen_create_block_form_validate($form, &$form_state) {
  $do_not_create_yet = file_directory_path()."/".$form_state['values']['module_name'];
  if (file_check_directory($do_not_create_yet, !FILE_CREATE_DIRECTORY)) {
    form_set_error('path ', t('Directory already exists. System must be able to create new path at #full_path', array('#full_path' => $do_not_create_yet)));
  }
}

function code_gen_create_block_form_submit($form, &$form_state) {
  require_once drupal_get_path('module', 'code_gen') . '/code_gen.common.inc';
  $template_path = BLOCK_TEMPLATES_PATH;

  $module_name = $form_state['values']['module_name'];
  $block_name = $form_state['values']['block_name'];
  $block_subject = ucwords(strtr($block_name, array("_" => " ")));

  $path = file_directory_path()."/".$module_name;

  _code_gen_create_standard_module_files($module_name, $path);
  //modulename.info
  _code_gen_copy_templates($template_path, "info.template",$path, $module_name.".info", array("%module_name" => $module_name));

  //modulename.module
  _code_gen_copy_templates($template_path, "module.template",$path, $module_name.".module",
                           array("%module_name" => $module_name,
                                 "%block_name" => $block_name,
                                 "%block_subject" => $block_subject,
                                 ));
}

