<?php
// $Id:
define('GENERIC_TEMPLATES_PATH', drupal_get_path('module', 'code_gen') .'/templates/generic');
$hook_defs = array();

function code_gen_generic_module() {
  $content = '<div id="code_gen_create_generic_module_form">';
    $content .= drupal_get_form('code_gen_create_generic_module_form');
  $content .= '</div>';
  return $content;
}
function code_gen_create_generic_module_form(&$form_state) {
  $form = array();
  $form['module_name'] = array(
    "#type" => "textfield",
    "#title" => t("Module name"),
    "#description" => t("Name of module to auto generate."),
    '#required' => TRUE,
  );
  $hooks = _code_gen_get_hook_names();
  $form['code_gen_hooks'] = array(
    "#type" => "select",
    "#multiple" => TRUE,
    "#title" => t("Create implementations of the following hooks"),
    "#options" => $hooks,
    "#description" => t("The selected hooks will be implemented in the simplest possible way, be prepared to add own stuff."),
    '#required' => TRUE,
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Create'),
  );
  return $form;
}

function code_gen_create_generic_module_form_validate($form, &$form_state) {
  $do_not_create_yet = file_directory_path()."/".$form_state['values']['module_name'];
  if (file_check_directory($do_not_create_yet, !FILE_CREATE_DIRECTORY)) {
    form_set_error('path ', t('Directory already exists. System must be able to create new path at #full_path', array('#full_path' => $do_not_create_yet)));
  }
}

function code_gen_create_generic_module_form_submit($form, &$form_state) {
  global $hook_defs;
  require_once drupal_get_path('module', 'code_gen') . '/code_gen.common.inc';
  $template_path = GENERIC_TEMPLATES_PATH;

  $module_name = $form_state['values']['module_name'];
  $path = file_directory_path()."/".$module_name;

  _code_gen_create_standard_module_files($module_name, $path);
  //modulename.info
  _code_gen_copy_templates($template_path, "info.template",$path, $module_name.".info", array("%module_name" => $module_name));
  //modulename.module
  $hook_implementations = array();
  foreach ($form_state['values']['code_gen_hooks'] as $hook_name) {
    $hook_implementations[] = strtr($hook_defs[$hook_name], array("%module_name" => $module_name));
  }
  _code_gen_copy_templates($template_path, "module.template",$path, $module_name.".module", array("%module_name" => $module_name, "%hook_implementations" => implode("\n",$hook_implementations)));

}

/**
 * Get the list of hook names.
 */
function _code_gen_get_hook_names() {
  global $hook_defs;
  $template_path = GENERIC_TEMPLATES_PATH;
  file_scan_directory($template_path, '^hook_[A-Za-z]+.template$', array('.','..','CVS'), '_code_gen_pass_hooks', FALSE);
  $out = "";
  foreach ($hook_defs as $hook_name => $hook_def) {
    $out[$hook_name] = $hook_name;
  }
  return $out;
}

/**
 * Pass templates for known hooks
 */
function _code_gen_pass_hooks($file_name) {
  global $hook_defs;
  $hook_name = substr($file_name,
                    strlen(GENERIC_TEMPLATES_PATH."/"),
                    strlen($file_name) - strlen(GENERIC_TEMPLATES_PATH."/") - strlen(".template"));
  $hook_defs[$hook_name] = file_get_contents($file_name);
}
